declare namespace atom = "http://www.w3.org/2005/Atom";
declare namespace atom03 = "http://purl.org/atom/ns#";
declare variable $inputDocument external;
declare variable $root := doc($inputDocument)/*;

declare function local:handleSummary($e as element(atom:entry))
   as element() {
                if (not(exists($e/atom:content))
                     or (exists($e/atom:content/@src)
                              or (exists($e/atom:content/@type)
                                          and (not($e/atom:content/@type = "xhtml"))
                                          and (not($e/atom:content/@type = "html"))
                                          and (not($e/atom:content/@type = "text")))
                             )
                )
                then <description baseUrl="{data($e/atom:summary/@xml:base)}">{$e/atom:summary/node()}</description>
                else <summary baseUrl="{data($e/atom:summary/@xml:base)}">{$e/atom:summary/node()}</summary>
};

declare function local:handle03Summary($e as element(atom03:entry))
   as element() {
                if (not(exists($e/atom03:content))
                              or (exists($e/atom03:content/@type)
                                          and (not($e/atom03:content/@type = "application/xhtml+xml"))
                                          and (not($e/atom03:content/@type = "text/html"))
                                          and (not($e/atom03:content/@type = "text/plain"))
                             )
                )
                then <description baseUrl="{data($e/atom03:summary/@xml:base)}">{$e/atom03:summary/node()}</description>
                else <summary baseUrl="{data($e/atom03:summary/@xml:base)}">{$e/atom03:summary/node()}</summary>
};

declare function local:handleContent($e as element())
   as element()* {
                if ((exists($e/@src))
                   or ((exists($e/@type))
                        and  (not($e/@type = "xhtml"))
                        and (not($e/@type = "html"))
                        and (not($e/@type = "text"))
                   ))
                then ()
                else <description baseUrl="{data($e/@xml:base)}"> {($e/node())} </description>
};


declare function local:handle03Content($e as element())
   as element()* {
                   if (not(exists($e/@type))
                        or  ($e/@type = "text/plain")
                        or ($e/@type = "text/html")
                        or ($e/@type = "application/xhtml+xml")
                   )
                then <description baseUrl="{data($e/@xml:base)}">{($e/node())}</description>
                else ()
};


(: Start of channel. Store any attributes in "feed" node :)
   <channel baseUrl="{data($root/@xml:base)}">{$root/@*}
    {
    for $x in  $root/*
    return
    (: Parse only the nodes belonging to Atom namespace  :)
       if ((namespace-uri($x) eq "http://www.w3.org/2005/Atom") or (namespace-uri($x) eq  "http://purl.org/atom/ns#"))
       then
       if (local-name($x) = "title")
       then <title> { string($x) }</title>
       else if ((local-name($x) = "subtitle") or (local-name($x) = "tagline"))
       then <description>{ string($x) } </description>
       else if (local-name($x) = "icon")
       then <image>{ string($x) } </image>
       else if ((local-name($x) = "logo") and (not(exists($root/atom:icon))))
       then <image>{ string($x) } </image>
       else if (local-name($x) = "link")
       then if (($x/@rel = "alternate") or (not(exists($x/@rel))))
       then <link>  { $x/string(@href)  }</link>
       else ()    (: Ignore any other link tag :)
       else if (local-name($x) = "entry")
       then
       (: Handle message nodes :)
          <message baseUrl="{data($x/@xml:base)}">
           {
                for $m in $x/*
                return
       if ((namespace-uri($x) eq "http://www.w3.org/2005/Atom") or (namespace-uri($x) eq  "http://purl.org/atom/ns#"))
                then if (local-name($m) = "title")
                then <title>{string($m)}</title>
                else if ((local-name($m) = "updated") or (local-name($m) = "modified"))
                then  <pubDate> { string($m) }</pubDate>
                else if (local-name($m) = "id")
                then <id> { string($m) }</id>
                else if (local-name($m) = "content")
        then if (namespace-uri($m) eq "http://www.w3.org/2005/Atom")
                  then local:handleContent($m)
                                  else local:handle03Content($m)
                else if (local-name($m) = "summary")
        then if (namespace-uri($m) eq "http://www.w3.org/2005/Atom")
                  then local:handleSummary($x)
                                  else local:handle03Summary($x)
                else if (local-name($m) = "link")
                then if (($m/@rel = "alternate") or (not(exists($m/@rel))))
                then <link>  { $m/string(@href)  }</link>
                else if ($m/@rel = "enclosure")
                then <enclosure url="{data($m/@href)}" type="{data($m/@type)}" size="{data($m/@length)}" baseUrl="{data($m/@xml:base)}"> </enclosure>
                else ()     (: Ignore any other link tags :)
                else ()     (: Ignore any other unhandled ATOM tags :)
                else $m     (: Pass on the NON-ATOM tags in message as they are. It could be handled in the XmlConverter  :)
                }
               </message>
                 (: End of message nodes :)

        else ()  (: Ignore other ATOM nodes as they are not handled :)

    else $x   (: Pass any other NON-ATOM nodes in channel as they are :)
    }
</channel>  (: End of channel :)
