declare variable $inputDocument external;
declare variable $root := doc($inputDocument)/*;

(: Start of channel. Store any attributes from "rss" node :)
   <channel baseUrl="{data($root/@xml:base)}">{$root/@*}
    {
    for $node in  $root/channel/*
    return
    (: Parse the channel nodes :)
       if (name($node) = "title")
       then <title> { string($node) }</title>
       else if (name($node) = "description")
       then <description> { string($node) } </description>
       else if (name($node) = "link")
       then <link> { string($node) } </link>
       else if (name($node) = "image")
       then <image> { string($node/url) } </image>
       else if (name($node) = "pubDate")
       then <pubDate> { string($node) } </pubDate>
       else if (name($node) = "item")
       then
       (: Handle message nodes :)
           <message baseUrl="{data($node/@xml:base)}">
           {
            for $x in $node/*
            return
                if (name($x) = "title")
                then <title>{string($x)}</title>
                else if (name($x) = "link")
                then <link>{string($x)}</link>
                else if (name($x) = "description")
                then <description baseUrl="{data($x/@xml:base)}">{($x/node())}</description>
                else if (name($x) = "pubDate")
                then <pubDate>{ string($x)}</pubDate>
                else if (name($x) = "guid")
                then if ((not(exists($node/guid/@isPermaLink)))
                         or ($node/guid/@isPermaLink = "true"))
                     then <id isPermaLink="true">{string($x)}</id>
                     else <id isPermaLink="false">{string($x)}</id>
                else if (name($x) = "enclosure")
                then <enclosure url="{data($x/@url)}" type="{data($x/@type)}" size="{data($x/@length)}" baseUrl="{data($x/@xml:base)}"></enclosure>
                else if (namespace-uri($x) = "")
                then ()        (: Ignore all unhandled message nodes.  Note: Rss feeds do not have any default namespace as per spec :)
                else $x        (: Allow all namespace nodes :)
           }
           </message>
       else if (namespace-uri($node) = "")
       then ()           (: Ignore all unhandled channel nodes.  Note: Rss feeds do not have any default namespace as per spec :)
       else $node        (: Allow all namespace nodes :)
    }
</channel>
